力扣1005:k次取反后最大化的数组和

力扣1005:k次取反后最大化的数组和

题目

给你一个整数数组 nums 和一个整数 k ,按以下方法修改该数组:

· 选择某个下标 i 并将 numsi 替换为 -numsi 。

重复这个过程恰好 k 次。可以多次选择同一个下标 i 。

以这种方式修改数组后,返回数组 可能的最大和 。

思路

这道题的关键点在于六个字:可以多次选择!

所以我们想要获得最大和我们就要在k还没到0前先从小到大的把负数变为正数,然后就有两种情况,k耗尽了或者是没有负数了。这时候我们再分情况讨论即可,如果k耗尽了那么最大和毋庸置疑就是当前数组的和,如果是没有负数了那么面对全部都是正数的数组我们就再需要分情况讨论了也就是当前k的值是偶数还奇数。如果k是偶数因为可以多次选择一个位置来取得相反数也就是-1的偶次幂,也就是1那么答案还是当前数组的和,如果k是奇数那就是一个位置的值要变成相反数了。那么选择哪个位置呢?当然是最小数。

代码

cpp 复制代码
class Solution {
public:
    int largestSumAfterKNegations(vector<int>& nums, int k) {
        int n = nums.size();
        int res = 0;
        // 按升序进行排序
        sort(nums.begin(), nums.end());
        for (int i = 0; i < n; i++) {
            // 如果有负数并且k大于0说明这个负数可以变成正数
            if (nums[i] < 0 && k > 0) {
                nums[i] = -nums[i];
                k--;
            }
            res += nums[i];
        }

        // 再排一次,让最小的数排前面
        sort(nums.begin(), nums.end());
        if (k % 2 != 0) {
            // 如果k为奇数我们就要让res加上最小数的相反数
            // 所以res等于加上两倍的最小数,当然这个最小数不知道是正是负
            res += -1 * 2 * nums[0];
        }
        // 如果k为偶数那么res就不用动,因为可以多次相反
        // 偶数次就直接抵消了
        return res;
    }
};
相关推荐
秋天的怀念_David5 分钟前
第二十一夜 · 数字黑洞与西西弗斯的惩罚
java·程序人生·算法
碧海银沙音频科技研究院1 小时前
在PC电脑上用Whisper→Marian算法实现离线语音翻译功能
算法·whisper
niyongsheng1 小时前
3D 装箱算法工程化:数据结构、放置启发式与支撑规则
数据结构·算法·rust
叉烧滑蛋3 小时前
B站台湾大学郭彦甫|MATLAB 学习笔记|04 变量与档案存取
数据结构
j7~4 小时前
【穷举、深搜与回溯算法】一棵决策树讲透全排列与子集
数据结构·c++·算法·leetcode·回溯·递归
傅科摆 _ py5 小时前
DP,贪心,堆和栈,二分力扣复习
开发语言·python·算法
Shaoshing5 小时前
LeetCode100 42.接雨水
java·算法·leetcode
域限奇点访客5 小时前
用AI生成问卷的网站怎么选?看题目录入结构、题型映射和生成后的校验
算法
文丑颜不良啊6 小时前
LeetCode1261~1280题目解析
java·leetcode
not coder6 小时前
一文讲通--从树到红黑树
数据结构·算法